OGRE: Ogre::FileStreamDataStream Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::FileStreamDataStream Class Reference
Core » Resources

Common subclass of DataStream for handling data from std::basic_istream. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::FileStreamDataStream:
[legend]

## Public Member Functions
| FileStreamDataStream (const String &name, std::fstream *s, bool freeOnClose=true)
| Construct named read-write stream from an STL stream.
| FileStreamDataStream (const String &name, std::fstream *s, size_t size, bool freeOnClose=true)
| Construct named read-write stream from an STL stream, and tell it the size.
| FileStreamDataStream (const String &name, std::ifstream *s, bool freeOnClose=true)
| Construct named read-only stream from an STL stream.
| FileStreamDataStream (const String &name, std::ifstream *s, size_t size, bool freeOnClose=true)
| Construct named read-only stream from an STL stream, and tell it the size.
| FileStreamDataStream (std::fstream *s, bool freeOnClose=true)
| Construct a read-write stream from an STL stream.
| FileStreamDataStream (std::ifstream *s, bool freeOnClose=true)
| Construct a read-only stream from an STL stream.
| ~FileStreamDataStream ()
void | close (void) override
| Close the stream; this makes further operations invalid.
bool | eof (void) const override
| Returns true if the stream has reached the end.
size_t | read (void *buf, size_t count) override
| Read the requisite number of bytes from the stream, stopping at the end of the file.
size_t | readLine (char *buf, size_t maxCount, const String &delim="\n") override
| Get a single line from the stream.
void | seek (size_t pos) override
| Repositions the read point to a specified byte.
void | skip (long count) override
| Skip a defined number of bytes.
size_t | tell (void) const override
| Returns the current byte offset from beginning.
size_t | write (const void *buf, size_t count) override
| Write the requisite number of bytes from the stream (only applicable to streams that are not read-only).
Public Member Functions inherited from Ogre::DataStream
| DataStream (const String &name, uint16 accessMode=READ)
| Constructor for creating named streams.
| DataStream (uint16 accessMode=READ)
| Constructor for creating unnamed streams.
virtual | ~DataStream ()
uint16 | getAccessMode () const
| Gets the access mode of the stream.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
const String & | getName (void)
| Returns the name of the stream, if it has one.
virtual bool | isReadable () const
| Reports whether this stream is readable.
virtual bool | isWriteable () const
| Reports whether this stream is writeable.
template<typename T>
DataStream & | operator>> (T &val)
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.
virtual size_t | skipLine (const String &delim="\n")
| Skip a single line from the stream.

## Additional Inherited Members
Public Types inherited from Ogre::DataStream
enum | AccessMode { READ = 1 , WRITE = 2 }

## Detailed Description

Common subclass of DataStream for handling data from std::basic_istream.

## Constructor & Destructor Documentation

## ◆ FileStreamDataStream() [1/6]

Ogre::FileStreamDataStream::FileStreamDataStream | ( | std::ifstream * | s,
|  | bool | freeOnClose = true )

Construct a read-only stream from an STL stream.

Parameters

  s | Pointer to source stream
  freeOnClose | Whether to delete the underlying stream on destruction of this class

## ◆ FileStreamDataStream() [2/6]

Ogre::FileStreamDataStream::FileStreamDataStream | ( | std::fstream * | s,
|  | bool | freeOnClose = true )

Construct a read-write stream from an STL stream.

Parameters

  s | Pointer to source stream
  freeOnClose | Whether to delete the underlying stream on destruction of this class

## ◆ FileStreamDataStream() [3/6]

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::ifstream * | s,
|  | bool | freeOnClose = true )

Construct named read-only stream from an STL stream.

Parameters

  name | The name to give this stream
  s | Pointer to source stream
  freeOnClose | Whether to delete the underlying stream on destruction of this class

## ◆ FileStreamDataStream() [4/6]

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::fstream * | s,
|  | bool | freeOnClose = true )

Construct named read-write stream from an STL stream.

Parameters

  name | The name to give this stream
  s | Pointer to source stream
  freeOnClose | Whether to delete the underlying stream on destruction of this class

## ◆ FileStreamDataStream() [5/6]

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::ifstream * | s,
|  | size_t | size,
|  | bool | freeOnClose = true )

Construct named read-only stream from an STL stream, and tell it the size.

This variant tells the class the size of the stream too, which means this class does not need to seek to the end of the stream to determine the size up-front. This can be beneficial if you have metadata about the contents of the stream already.

Parameters

  name | The name to give this stream
  s | Pointer to source stream
  size | Size of the stream contents in bytes
  freeOnClose | Whether to delete the underlying stream on destruction of this class. If you specify 'true' for this you must ensure that the stream was allocated using OGRE_NEW_T with MEMCATEGRORY_GENERAL.

References Ogre::DataStream::size().

## ◆ FileStreamDataStream() [6/6]

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::fstream * | s,
|  | size_t | size,
|  | bool | freeOnClose = true )

Construct named read-write stream from an STL stream, and tell it the size.

This variant tells the class the size of the stream too, which means this class does not need to seek to the end of the stream to determine the size up-front. This can be beneficial if you have metadata about the contents of the stream already.

Parameters

  name | The name to give this stream
  s | Pointer to source stream
  size | Size of the stream contents in bytes
  freeOnClose | Whether to delete the underlying stream on destruction of this class. If you specify 'true' for this you must ensure that the stream was allocated using OGRE_NEW_T with MEMCATEGRORY_GENERAL.

References Ogre::DataStream::size().

## ◆ ~FileStreamDataStream()

Ogre::FileStreamDataStream::~FileStreamDataStream | ( |  | ) |

## Member Function Documentation

## ◆ read()

size_t Ogre::FileStreamDataStream::read | ( | void * | buf,
|  | size_t | count )
| overridevirtual

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns
  The number of bytes read

Implements Ogre::DataStream.

## ◆ write()

size_t Ogre::FileStreamDataStream::write | ( | const void * | buf,
|  | size_t | count )
| overridevirtual

Write the requisite number of bytes from the stream (only applicable to streams that are not read-only).

Parameters

  buf | Pointer to a buffer containing the bytes to write
  count | Number of bytes to write

Returns
  The number of bytes written

Reimplemented from Ogre::DataStream.

## ◆ readLine()

size_t Ogre::FileStreamDataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = "\n" )
| overridevirtual

Get a single line from the stream.

The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns
  The number of bytes read, excluding the terminating character

Reimplemented from Ogre::DataStream.

## ◆ skip()

void Ogre::FileStreamDataStream::skip | ( | long | count | ) |
| overridevirtual

Skip a defined number of bytes.

This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.

Implements Ogre::DataStream.

## ◆ seek()

void Ogre::FileStreamDataStream::seek | ( | size_t | pos | ) |
| overridevirtual

Repositions the read point to a specified byte.

Implements Ogre::DataStream.

## ◆ tell()

size_t Ogre::FileStreamDataStream::tell | ( | void |  | ) | const
| overridevirtual

Returns the current byte offset from beginning.

Implements Ogre::DataStream.

## ◆ eof()

bool Ogre::FileStreamDataStream::eof | ( | void |  | ) | const
| overridevirtual

Returns true if the stream has reached the end.

Implements Ogre::DataStream.

## ◆ close()

void Ogre::FileStreamDataStream::close | ( | void |  | ) |
| overridevirtual

Close the stream; this makes further operations invalid.

Implements Ogre::DataStream.

The documentation for this class was generated from the following file:

- OgreDataStream.h